package myShell;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.util.Calendar;

/**
 * It is used to write a log file explaining the steps the program went through during its execution.
 * 
 * @author Leo PERRIN (perrin.leo@gmail.com)
 *
 */
public class LogWriter {
	
  //	
  //	fields
  //	
	
	/**
	 * The name of the written file.
	 */
	String logName;


  //
  //	Constructor
  //

	/**
	 * Creates an instance of LogWriter and writes the current date in it.
	 */
	public LogWriter()
	{
		Calendar cal = Calendar.getInstance();
		String date = cal.get(Calendar.DATE) + "-" + (cal.get(Calendar.MONTH)+1) + "-" +
				cal.get(Calendar.YEAR) + "-(" +	cal.get(Calendar.HOUR_OF_DAY) + ":" +
				cal.get(Calendar.MINUTE) + ":" + cal.get(Calendar.SECOND) + ")";
		this.logName = "../data/log/" + date + ".log" ;
		this.append(" ----- started at : " + date + "\n\n");
	}


  //
  //	Method
  //
	
	/**
	 * Appends the String "line" at the end of the log file and prints it on the screen.
	 * @param	line	The line to be appended in the file.
	 */
	public void append(String line)
	{
		System.out.println(line);
		try
		{
			BufferedWriter logFile = new BufferedWriter
		  			(new FileWriter(this.logName,true));
			logFile.write(line);
			logFile.newLine();
			logFile.close();
		}
		catch (Exception e) { e.printStackTrace(); }
	}

	
	/**
	 * Writes the finishing time in the log file.
	 */
	public void finish()
	{
		Calendar cal = Calendar.getInstance();
		String date = cal.get(Calendar.DATE) + "-" + (cal.get(Calendar.MONTH)+1) + "-" +
				cal.get(Calendar.YEAR) + "-(" +	cal.get(Calendar.HOUR_OF_DAY) + ":" +
				cal.get(Calendar.MINUTE) + ":" + cal.get(Calendar.SECOND) + ")";
		append("\n ----- finished at : " + date);
	}
}
