#!/usr/bin/env python
# -*- coding: UTF-8 -*-

import random

class Turker():
	"""Emulates the behaviour of a turker: answers question with a given
	error rate (set at construction)."""


	def __init__(self,errRate):
		"""Sets the 'id' and 'errorRate' attributes."""
		self.id = self.generateId()
		self.errorRate = errRate


	def generateId(self):
		"""Generates a random identifier made of 10 hexadecimal numbers."""
		id = ""
		for i in range(0,9):
			id += random.choice(['1','2','3','4','5','6','7','8','9','a','b','c','d','e','f'])
		return id


	def correct(self):
		"""Returns False if a random parameter is lower than the
		turker's 'errorRate' attribute, True otherwise."""
		if (random.random() < self.errorRate):
			return False
		else:
			return True


	def testClass(self,number):
		"""Tests the functionnalities of this class."""
		print "testing the Turker class:\n"
		print "id = " + str(self.id)
		print "errorRate = " + str(self.errorRate)
		trueCount = 0.0
		falseCount = 0.0
		for i in range(0,number):
			if (self.answer(True)):
				trueCount += 1
			else:
				falseCount += 1
		print ( str(falseCount) +" False seen among "+ str(number)
				+ " answers, which correspond to this error rate: "
				+ str(falseCount/(trueCount+falseCount) * 100) + "%\n" )
		print "\neverything seems to have gone fine...\n"


# --------------- TEST

if (__name__ == "__main__"):
	tk = Turker(0.1)
	tk.testClass(100)
