<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
	<?php
		include('utils.php');
		printHeader("Crowd Powered Sort","Home");
	?>

	<h4>What is CPS?</h4>

	<p>Crowd Powered Sort is a java application allowing an easy use of <a href="https://secure.wikimedia.org/wikipedia/en/wiki/Crowdsourcing">crowdsourcing</a> to place media continuously along one or several axis.</p>

	<h4>What CPS should <em>not</em> be used for?</h4>
	<p>If you can use a "real" algorithm (i.e, one that does not require any human intervention) to place your media along the axis you want, then you definitely should not use it. Indeed, while this software is free, the workers performing the comparisons must be paid, which could turn out to be rather expensive.</p>
	<p>You should also avoid using it if you want to place your media in a discrete small number of categories : the results of CPS are continuous and, actually, the hole interest of CPS is in this continuity. It is much more complex!</p>

	<h4>Principle</h4>
	<p>The coordinate along each axis is found by sorting the media using a <a href="principle/principle.php">splitsort</a> and then associates to their rank in the list a coordinate. The splitsort separates comparisons from the rest of the algorithm in order them to be performed by humans: this is where crowdsourcing enters. Indeed, comparisons are performed by human workers rather than machines.  Therefore, CPS can be used to sort media along very <b>subjective</b> axes, such as <em>happiness</em> or <em>pleasure</em>.</p>

	<h4>Why CPS?</h4>
	<p>CPS was ordered by the <a href="http://liris.cnrs.fr/">LIRIS</a> <em>(Laboratoire d'InfoRmatique en Images et Systemes d'information)</em>, a French laboratory studying, among other things, the way the emotion conveyed by a media could be recognized by an algorithm. In order to generate a database containing a huge amount of media (several thousands or even more than ten thousand) tagged with the correct level of emotion, CPS was designed. However, though its primary use is rather specific, you can use it to have media put on any axis you want by human workers.</p>

	<h4>Crowdsourcing provider</h4>
	<p>CPS uses <a href="https://crowdflower.com/self-service"><em>self-service</em></a>, a crowdsourcing solution provided by <a href="https://crowdflower.com/">CrowdFlower</a>. Unlike <a href="https://www.mturk.com/mturk/welcome">Amazon's Mechanical Turk</a>, it is not necessary to be american to use it.</p>

	<h4>How does it work ?</h4>
	<p>If you want more information on how this works, you are at the right place! This website contains CPS's documentation and useful <a href="https://secure.wikimedia.org/wikipedia/en/wiki/PHP"><!--the language whose name should not be pronounced-->PHP</a> scripts. It is divided in several parts:</p>
	<ul>
		<li>
			<a href="install/"><h3>Install</h3></a>
			<p>Before going any further, you should download and install CPS. It is <em>very</em> easy.</p>
		</li>
		<li>
			<a href="userManual/"><h3>User Manual</h3></a>
			<p>If you want to learn how to configure and use this software, this where you should go.</p>
		</li>
		<li>
			<a href="principle/"><h3>Principle of the Algorithm</h3></a>
			<p>This one describes the design and the general ideas behind the algorithm implemented.</p>
		</li>
		<li>
			<a href="antechamber/"><h3>Antechamber</h3></a>
			<p>As you will learn <a href="principle/components.php">here</a>, CPS uses PHP scripts hosted on an external webserver called the <a href="principle/antechamber.php">antechamber</a> to retrieve results and send e-mail. Such scripts are in that section of this website.</p>
		</li>
		<li>
			<a href="doxygen/html/"><h3>Doxygen</h3></a>
			<p>At last, this is the code documentation, generated using <a href="http://www.stack.nl/~dimitri/doxygen/">doxygen</a>. It is similar to a Javadoc, except it is better! Still, if you want to take a look at a "classical" Javadoc, there is one <a href="documentation/javadoc.php">here</a>.</p>
		</li>
	</ul>

	<?php
		printFooter();
	?>
</html>
