<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
	<?php
		include('docUtils.php');
		principleHeader('Principle of the splitsort');
		principleMenu("principle.php");
	?>


	<h2>Context</h2>
	<div class="diagramm">
		<p>The aim of this program is to place media along an axis in a way determined by human workers. However, since crowdsoucing is used, there is no reason to allege the wokers are qualified. Furthermore, if you must have human doing this classification, the criteria used is most likely very subjective : it would definitely NOT be a good idea to ask them to simply give, say, a mark between one an ten. Even making an average may not be the solution because each question is paid : it could be very costly, without assuring a significant augmentation of the overall quality of the results.</p>
	</div>


	<h2>The ideas behind the splitsort</h2>

	<div class="diagramm">
		<h3>On the use of comparisons rather than marks</h3>
		<p>Workers cannot be asked to answer a complex or too subjective question such as giving a mark between one and ten to a media :we are not sure of the quality of the results and doing so would require you to pay more for each question. Therefore, CPS only asks them to perform a comparison between to media : "<tt> which one is the most 'your axis'?</tt>".</p>

		<h3>From comparisons to a coordinate</h3>
		<p>All right, workers answer comparisons, it is more sure. But how do we use them to give each media a coordinate? The trick is to assume media follow a given <a href="https://secure.wikimedia.org/wikipedia/en/wiki/Probability_distribution">distribution</a> along <tt>'your axis'</tt> (here, a <a href="https://secure.wikimedia.org/wikipedia/en/wiki/Uniform_distribution_%28discrete%29">uniform</a> one, but this can be modified by re-writing the <tt><a href="/doxygen/html/classmyShell_1_1Interpreter.html#a7536727f0e60d14ff28001ed45632e80">rank2value()</a></tt> method). We sort media using a quicksort and then give a value to their rank given the distribution their supposed to follow.</p>

		<h3>On the separation of the comparisons from the sort</h3>
		<p>In order to increase even more the quality of the results, CPS submits the results of the comparisons to a program, <tt><a href="http://code.google.com/p/get-another-label/">get another label</a></tt>, written by P. Ipeirotis (an american researcher specialised in crowdsourcing, more info on his <a href="http://behind-the-enemy-lines.blogspot.com/">blog</a>) and his students. Based on confusion matrix, it increases the quality of the results.</p>
		<p>However, in order this to be efficient, it must be sent as many comparisons at a time as possible. That is why comparisons are gathered before they are sent to <a href="https://crowdflower.com">CrowdFlower</a>. This also limits the number of uploads.</p>
		<p>The part that performs the quicksort and the one that compares the media are split, hence <b>split</b>sort.</p>
	</div>


	<h2>A scheme of the splitsort principle</h2>

	<div class="diagramm">
		In order for all this to be more clear, let's take a look at an example. Even though it is rather... <em>interesting</em> to consider that six media will follow any type of probability distribution, we will say they do for the sake of the example. So, we have six media to place along <tt>'your axis'</tt>, <tt>M1, M2, M3, M4, M5 and M6</tt>. If have never heard of the quicksort before, you may consider doing your <a href="https://secure.wikimedia.org/wikipedia/en/wiki/quicksort">homework</a> before going any further. Now, release the splitsort!


	<h3>First iteration</h3>
		<p>First, just like a "normal" quicksort, we choose a <em>pivot</em>. CPS always takes the first element of the array to sort. Here, it is <tt>M1</tt>. Comparisons are then generated : in order to continue, we need to compare if <tt>(M1 and M2), (M1 and M3), (M1 and M4), (M1 and M5)</tt> and <tt>(M1 and M6)</tt>. These comparisons are then sent to a crowd that performs them. Results are then retrieved and processed using <tt>get another label</tt>.</p>
		<p>We now have good results, so we can finish our quicksort iteration. As it turned out, <tt>(M1 > M3,M4,M6)</tt> and <tt>(M1 < M2,M5)</tt>, so we split the initial array in three : one that contains the smallest (<tt>M3,M4,M6</tt>), one that contains the pivot (<tt>M1</tt>) and one that contains the greatest (<tt>M2,M5</tt>).
		<div align="center"><img src="figures/algo1-en.png" height="500" width="710" alt="a scheme representing the first iteration of a splitsort"></div>
		</p>


	<h3>Second iteration</h3>
		<p>We are not done yet, another iteration must be performed. Again, we choose the first element of each array as the pivot, therefore they are <tt>M3</tt> and <tt>M2</tt>. We then go through the same steps as the first iteration, but there is one thing you must notice : all comparisons, either for the first or the second array, are submitted at the same time! In the end of this iteration, the media are sorted.
		<div align="center"><img src="figures/algo2-en.png" height="500" width="710" alt="a scheme representing the second iteration of the same splitsort"></div>
		</p>


	<h3>Placing media</h3>
		<p>Now that we are done with sorting, it is time to place the media along <tt>'your axis'</tt>. Assuming they follow a <a href="https://secure.wikimedia.org/wikipedia/en/wiki/Uniform_distribution_%28discrete%29">uniform distribution</a> within <tt>[-1,1]</tt>, it will look like this :
		<div align="center"><img src="figures/algo3-en.png" height="155" width="710" alt="the result : media are sorted along <your axis>">
		</p></div>
		<p>Tada! You have your results and are therefore most likely very happy.</p>
	</div>


	<?php printFooter(); ?>
</html>
