<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
	<?php
		include('docUtils.php');
		principleHeader('UML modelisation');
		principleMenu("uml.php");
	?>

	<h2>Tool used</h2>
	<div class="diagramm">
		<p>All these diagram where created using <a href="http://www.umbrello.org/">umbrello</a>, an open-source and free program able to generate as well as read Java code. CPS was designed with this powerfull tool. It allows the generation of code in several languages (among which Java) as well as the importation of files written in the same languages. Furthermore, the generated code contains javadoc formatted commentaries containing all the variable, class, method, etc. descriptions recorded.</p>
	</div>

	<h2>Before going any further</h2>
	<div class="diagramm">
		<p>This page describes the way <a href="principle.html">splitsort</a> is implemented in CPS. If you have not read the <a href="principle.html">principle</a> page of this documentation yet, you are highly recommended to do it now. If you plan to use CPS, <a href="checklist.html">here</a> is a checklist containing everything you should have before starting.</p>
	</div>


	<h2>Class Diagram</h2>
	<div class="diagramm">
	<div align="center"><img src="figures/class-diagram.png" alt="CPS's class diagram"></div>
	<div class="explanations">
		Legend:
		<ul>
			<li>red: <a href="namespacesorter.html">sorter</a></li>
			<li>blue: <a href="namespacemyShell.html">myShell</a></li>
			<li>green: <a href="namespacemyDataBases">myDataBases</a></li>
			<li>yellow: <a href="namespacecrowdUser">crowdUser</a></li>
		</ul>
	</div>
	</div>

	<h2>Global sequence diagram of the CPS</h2>
	<div class="diagramm">
	<div align="center"><img src="figures/use.png" alt="a sequence diagramm describing the general steps of a CPS execution"></div>
	<div class="explanations">
		<p>This sequence diagram explains how the interaction between the user and CPS works in order for media to be placed along the specified axes.</p>
		<ol>
			<li><p>First of all, the user calls CPS with the the <tt>new</tt> parameter using this command:</p>
			<div class="shell">./cps.sh --new 'insert here the DB password'</div>
			<p>It checks several thing (connection to the MySQL database, content of the <a href="inter_files.html"><tt>config.xml</tt> file</a>, etc) beofre going any further, as explained below (<tt>initialize</tt> method).</p></li>
			<li>Such a command triggers the call of the <tt>MainClass.generateJob()</tt> method, a function that will perform the first half of a splitsort iteration. The details of this "first half" are explained in another sequence diagram below. In doing so, CPS uploads data to be used in HITs to <a href="https://www.crowdflower.com">CrowdFlower</a>.</li>
			<li>A loop "powered" by the user then starts. It will stop when media are placed along each axis (or when the user is bored and stops firing new iterations).
				<h4>Inside the loop</h4>
				<ol>
					<li>When all the HITs for a job have been submitted, CrowdFlower sends a <a href="https://crowdflower.com/docs/api/webhooks">webhook</a> to the <a href="antechamber.php">antechamber</a> at an address set <strong>before using this software</strong> using their <a href="https://crowdflower.com/jobs">web interface</a>. A <a href="php.html">PHP script</a>, when receiving this webhook, transforms its content into a csv file and sends a mail at a given address <strong>which you also have tp set before</strong>.</li>
					<li><p>When receiving this email, the user logs on the machine hosting CPS and uses:</p>
					<div class="shell">./cps.sh --iteration 'insert here the DB password'</div>
					<p>This triggers a splitsort iteration.</p></li>
					<li>First, the part of the iteration corresponding to the retrieving of the results is performed by downloading HITs results from the <tt>antechamber</tt>.</li>
					<li>Then, these results are read and interprated by CPS to fill the database with comparison results.</li>
					<li>These results are used in the next part of the iteration to create new HITs to upload.</li>
					<li>The data for the new HITs is uploaded to CrowdFlower where they will be processed by workers.</li>
					<li>Temporary results along each axis are saved as well as the identifier of the CrowdFlower's job in which data was uploaded.</li>
				</ol>
			</li>
		</ol>
		<strong>Keep in mind that this diagram is only a scheme: the real one would be MUCH more complex. More details are available below.</strong>
	</div>
	</div>

	<h2>Initialisation</h2>
	<div class="diagramm">
	<div align="center"><img src="figures/initialize.png"></div>
	<div class="explanations">
		<p>This sequence diagram describes how the classes used to perform the splitsort are initialised using the... <tt>initialize()</tt> method. The names diplayed are the actual names of the method, so feel free to browse the part of this website dedicated to the <a href="annotated.html">documentation</a> of each class in order to get more precision on how each method works.</p>
		<ol>
			<li><tt>getConfig()</tt> reads the content of the <a href="inter_files.html"><tt>config.xml</tt></a> file and returns, among other things, the <em>user</em> of the database, the path to the <a href="inter_files.html"><tt>media.xml</tt></a> file, etc. For more details, go <a href="inter_files.html"><tt>here</tt></a>.</li>
			<li><tt>getAxes()</tt> reads the same file and returns the axes along which the sort will be performed.</li>
			<li>A <tt>MediaBase</tt> instance is created in order to easily retrieve information on the media to sort later.</li>
			<li>An <tt>Interpreter</tt> instance is also built. Its role will be to write the results obtained in the correct file.</li>
			<li>This method then enter in a loop allowing to do the following actions for each axis:
				<ol>
					<li>Call the <tt>getCurrentState()</tt> function in order to know the current state of the media along this axis.</li>
					<li>A <tt>SplitSort</tt> instance is created using the data returned by the previous method.</li>
					<li>Whether the sort along this axis is finished is checked.</li>
				</ol>
			</li>
			<li>The program then enters in an if statement:
				<ul>
					<li>If it turns out that <tt>notFinished()</tt> is true at least for one axis:
					<ol>
						<li>A <tt>MySQLbase</tt> instance is created to allow the program to communicate with the database.</li>
						<li>A <tt>Comparator</tt> instance is built to manage the sort along every axes,to gather the comparisons and to send them to...</li>
						<li>A <tt>CrowdManager</tt> instance which is created right after.</li>
					</ol>
					</li>
					<li>Otherwise, the sort is finished:</li>
					<ol>
						<li>A <tt>Comparator</tt> instance is created using a constructor that will not set its <tt>MySQLbase</tt> attribute because it will not be necessary.</li>
						<li>The <tt>Interpreter</tt> generates the <a href="inter_files.html"><tt>results.xml</tt></a> file.</li>
					</ol>
				</ul>
			</li>
		</ol>
	</div>
	</div>

	<h2>The <tt>generatingJob()</tt> method</h2>
	<div class="diagramm">
	<div align="center"><img src="figures/generateJob.png"></div>
	<div class="explanations">
		<p>This diagram describes the <tt>generatingJob()</tt> method.</p>
		<ol>
			<li>First of all, every instances are initialised with the <tt>initialize()</tt> method.</li>
			<li>Using his <tt>sortIteration()</tt> method, the Comparator enters in a loop:
				<ol>
					<li>Along each axis, the corresponding SplitSort instance contained in the <tt>sorters</tt> attribute uses its <tt>iteration()</tt> method.</li>
					<li>In doing so, each <tt>SplitSort</tt> uses <tt>addComparisons()</tt> to generate the comparisons it needs.</li>
					<li>The <tt>Comparator</tt> gathers the comparisons using <tt>SplitSort</tt>'s <tt>getGreater()</tt> and <tt>getSmaller()</tt>.</li>
				</ol>
			</li>
			<li>The <tt>Comparator</tt> checks in the <tt>MySQLbase</tt> instance which comparisons have already been performed</li>
			<li>Unknown comparisons are submitted to a CrowdManager instance using <tt>demandNewComparisons()</tt>.</li>
			<li>It then creates a new job at CrowdFlower. To do so, it copies the job whose ID is in the <tt>config.xml</tt> file.</li>
			<li>The data necessary for <a href="https://www.crowdflower.com">CrowdFlower</a> to submit the job is then generated. It is a <a href="https://secure.wikimedia.org/wikipedia/en/wiki/Comma-separated_values">csv file</a> containing data such as the names of the media to compare and their identifier. This file is uploaded using a <tt>http PUT</tt>.</li>
		</ol>
		<p>Once all this has been done, you have to wait for the mail that will signal a webhook.</p>
	</div>
	</div>

	<h2>The <tt>Useresults()</tt> method</h2>
	<div class="diagramm">
	<div align="center"><img src="figures/useResults.png"></div>
	<div class="explanations">
		In this part, we assume that results have been downloaded and read.
		<ol>
			<li>The <tt>Comparator</tt> instance retrieves the comparisons results from the <tt>MySQLbase</tt> instance</li>
			<li>The comparisons are sent to each <tt>SplitSort</tt> instance using their <tt>endIteration()</tt> method that also triggers the splitting of all arrays in three parts using the <tt>insertion()</tt> method.</li>
			<li>A dump of the database is then generated in order for its content to be easily put back in it if anything went horribly wrong.</li>
			<li>In the end, <a href="https://secure.wikimedia.org/wikipedia/en/wiki/xml">xml</a> files containing the <a href="inter_files.html">intermediary results</a> along each axis are generated.</li>
		</ol>
	</div>
	</div>
	<?php printFooter(); ?>
</html>

