<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
	<?php
		include('manUtils.php');
		manHeader('Check Lists');
		manMenu("check.php");
	?>

	<h2>At CrowdFlower</h2>
	<div class="diagramm">
		<p>CPS uses CrowdFlower's API through the <tt>CrowdManager</tt> class. Therefore, you must use their service. Here is a list of what you need:</p>
		<ul>
			<li>A CrowdFlower <a href="http://crowdflower.com/self-service">self-service</a> account.</li>
			<li>Enough money in it to submit all the jobs you will require.</li>
			<li>The key given in your <a href="http://crowdflower.com/account">account page</a>.</li>
			<li>Now we will focus on the configuration of the first job. CPS will create new ones, but they will be copies of this one, so make sure everything is fine with it! You must feed it with:
			<ul>
				<li>A <a href="http://crowdflower.com/docs/cml">cml</a> template matching the information you want to retrieve from the HITs.</li>
				<li>An adress to which <a href="http://crowdflower.com/docs/api/webhooks">webhooks</a> are sent. It should contain a PHP script sending you a mail, or anything that will signal to you that a job is complete. You can set it in the <a href="http://crowdflower.com/jobs">"jobs"</a> tab of CrowdFlower's web interface. Select the job you will use, go in "edit", "advanced options" (a purple button on top of the page). A new pop-up window should appear. There, give the adress to which webhooks will be fired.</li>
				<li>While you are in this window, set tags, <em>i.e</em> keywords that will help the workers in choosing your job.</li>
				<li>
					The <tt>auto_order</tt> property should be set to <tt>true</tt> in order not for you to have to manually order the job. To do so, type this into a UNIX-like terminal:
					<div class="shell">curl -X PUT --data-urlencode "job[auto_order]=true" "https://api.crowdflower.com/v1/jobs/$JOB_ID.json?key=$YOUR_KEY"</div>Where:
					<ul>
						<li><tt>$JOB_ID</tt> is the identifier of the job you will use.</li>
						<li><tt>$YOUR_KEY</tt> is the key CrowdFlower gave you (see above).</li>
					</ul>
				</li>
			</li>
			</ul>
		</ul>
	</div>


	<h2>Configuration file</h2>
	<div class="diagramm">
		<p>The <a href="xmlFiles.html"><tt>config.xml</tt></a> file you use must contain the following fields. It will be checked when a splitsort is launched.</p>
		<ul>
			<li><tt>mediaPath</tt> The path to the file containing information on the media used.</li>
			<li><tt>drop</tt> The size under which array will not be sorted.</li>
			<li><tt>sqlBase</tt> The name of the MySQL database used.</li>
			<li><tt>sqlUser</tt>The name of the user of the database.</li>
			<li><tt>antechamberUrl</tt> The URL of the <a href="principle/antechamber.php">antechamber</a> you will use.</li>
			<li><tt>cfKey</tt> The key CrowdFlower gave you (see above).</li>
			<li><tt>cfJobNumber</tt> The identifier of the job containing all the information needed: cml template, etc. (see above).</li>
		</ul>
		<p>The <a href="xmlFiles.html"><tt>media.xml</tt></a> file plays a crucial role. It contains the list of the media you want to place along each axis written in the <tt>config.xml</tt> file. In order for CPS to know the identifier, the url and whichever other information you would like to see on your <tt>results.xml</tt> file about each media, you must store it in. An example of how you should format this file is given in the <a href="xmlFiles.html">same page</a>. Two fields are compulsory, for each media:</p>
		<ul>
			<li><tt>id</tt> The identifier that will be used by CPS to identify this media during the process.</li>
			<li><tt>name</tt> The path where the media is stored. It is most likely a <a href="https://secure.wikimedia.org/wikipedia/en/wiki/URL">URL</a>.</li>
		</ul>
	</div>


	<h2>MySQL Database</h2>
	<div class="diagramm">
		<p>The MySQL database used by CPS has to be correctly configured. CPS will help you in this matter: it can write a SQL script creating the tables you require for this splitsort as well as the field necessary. It takes its information from the config.xml file, so make sure it is correctly configured!</p>
		<p>In order to create the script, just type:</p>
		<div class="shell">$> java -cp 'bin/:lib/*' myShell.MainClass --sql-file</div>
		<p>When it is done, retrieve the script in <tt>data/mysql</tt> (its exact name is displayed when you run the command) and use it to populate your database.</p>
	</div>


	<h2>AnteChamber</h2>
	<div class="diagramm">
		<p>The <a href="../documentation/antechamber.php"><tt>antechamber</tt></a> is the interface between CrowdFlower and you, as well as the one used by CPS to retrieve results.. While CPS can retrieve and upload results on its own, it cannot know when to start a new iteration. The <a href="../documentation/antechamber.php"><tt>antechamber</tt></a> is a solution to this, but it must have the correct configuration. For that, you must edit the <tt>main.php</tt> file.</p>
		<ul>
			<li>The mail address in the call to <tt>jobCompleteNotification()</tt> must be a valid one, <em>i.e</em> one you check regurlarly in order not to miss the signal.</li>
			<li>The <tt>trigger</tt> attribute must be set to "<tt>job_complete</tt>".</li>
		</ul>
		<p>For more information on this component, you can go <a href="../documentation/antechamber.php">here</a> and, in order to see how it fits in the global scheme, you should check <a href="../documentation/components.php">that</a>.</p>
	</div>

	<?php printFooter(); ?>
</html>
