<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
	<?php
		include('manUtils.php');
		manHeader('XML Files');
		manMenu("xmlFiles.php");
	?>

	<h2>Configuration: <tt>config.xml</tt></h2>
	<div class="diagramm">
		<p>The content of this file is rather fixed. The <a href="../doxygen/html/classmyShell_1_1Interpreter.html#a9e6507e6cd99a4101b73e29b9d6c732a"><tt>Interpreter.checkFile()</tt></a> method checks its content, so if made any change, you shoulduse it to see if everything is fine. Its default content is that of <a href="files/config.xml">this file</a>.</p>
		<p>In order to know what to put in the <tt>HardDataFields</tt> section, you can go log in your account at CrowdFlower after creating a <a href="cml.php">cml template</a> and uploading some fake data. After logging, go to <tt>https://crowdflower.com/jobs/$Job_Id.csv</tt>, where <tt>$Job_Id</tt> is of course the identifier of the job you plan to use. It should launch the downloading of a <a href="https://secure.wikimedia.org/wikipedia/en/wiki/Comma-separated_values">csv file</a> containing the job results.</p>
		<p>You do <strong>not</strong> need to order a job to download it: if there is no results available right know, which is most likely the case, you will simply download the structure of the results CPS will parse. This is all you need.</p>
		<p>The content of the <tt>HardDataFields</tt> should match the structure of this csv file.</p>
	</div>

	<h2>Media to sort: <tt>media.xml</tt></h2>
	<div class="diagramm">
		<p>The <tt>media.xml</tt> file contains all the information that is necessary for you to use your media. For instance, if you are using video extracted from several movies defined by their <a href="https://secure.wikimedia.org/wikipedia/en/wiki/Timecode">timecode</a>, you should use <a href="files/media.xml">this file</a>'s structure. While you can add all the information you want on each media, the following fields are mandatory:</p>
		<ul>
			<li>
				<h3><tt>id</tt>:</h3>
				<p>Corresponds to a number associated with each media. Two media can <strong>not</strong> have the same id.</p>
			</li>
			<li>
				<h3><tt>name</tt>:</h3>
				<p>The name of the media, <em>i.e</em> its URL.</p>
			</li>
			<li>
				<h3><tt>miscData</tt>:</h3>
				<p>Miscellaneous data to display along with the media, such as the name of the movie it is taken from, etc. If you do not want to use it: leave it empty, but <em>leave it</em>!</p>
			</li>
		</ul>
	</div>

	<h2>Intermediary results files: <tt>'axis'.xml</tt></h2>
	<div class="diagramm">
		<p>During its execution, after each iteration, CPS will create a file for each axis along which it has performed comparisons. For example, if you asked it to place media along the <tt>axis1</tt> and <tt>axis2</tt> axes, it will create <tt>axis1.xml</tt> and <tt>axis2.xml</tt> in the <tt>data/previously</tt> directory.</p>
		<p>These files contain the current state of the quicksort, <em>i.e</em> the way the identifier of the media are currently arranged along each axis. If you are not familiar with quicksort, you should go <a href="https://secure.wikimedia.org/wikipedia/en/wiki/Quicksort">here</a> first. The identifier are in arrays, each array waiting for the next iteration. These files save this structure, as you can see in <a href="files/axis.xml">this</a> example file: identifiers are grouped within "<tt>array</tt>" nodes, which is pretty self explanatory.</p>
	</div>

	<h2>Final results: <tt>results.xml</tt></h2>
	<div class="diagramm">
		<p>This file is generated by this program. It has the same structure as the media.xml file, except the coordinate along each axis is specified as well for each media. For example, <a href="files/results.xml">here</a>'s what it would look like if one had the strange idea of launching CPS on the previous <a href="files/media.xml"><tt>media.xml</tt></a> file.</p>
	</div>

	<?php printFooter(); ?>
</html>
